import threading
from pathlib import Path

from django.core.exceptions import ImproperlyConfigured

from djangotools.common.module_loader import iter_module_content


class CommandData:

    def __init__(self, **kwargs):
        for k, v in kwargs.items():
            setattr(self, k, v)


class Argument:
    def __init__(self, *args, **kwargs):
        self.args = args
        self.kwargs = kwargs

class ThreadWrapper(threading.Thread):

    def __init__(self, fct):
        super().__init__()
        self.fct = fct

    def run(self) -> None:
        return self.fct()


class Command:
    NAME = None
    HELP = None
    ALIASES = []

    ARGUMENT=None

    def __init__(self):
        pass

    def execute(self, data):
        return self.run(data)

    def run(self, data):
        raise NotImplementedError()

    @classmethod
    def thread_run(cls, data):
        cmd = cls()
        dd = {cmd.NAME: data}
        thread = ThreadWrapper(lambda x=dd: cmd.run(x))
        thread.start()
        return thread


    @staticmethod
    def load(commands_dirs=None):
        ret = {}
        for name, val in  iter_module_content(commands_dirs, classe=Command):
            if val.NAME:
                ret[val.NAME] = val

        return set(ret.values())







